Subject: Re: [i2rs] Kathleen Moriarty's No Objection on draft-ietf-i2rs-yang-l3-topology-08: (with COMMENT)

From: Lou Berger <[email-masked]>
Date: Wed, 25 Jan 2017 07:27:05 -0500

Sue,

In short, I'm going to agree with Benoit - but for slightly different
reasons as I also co-chair TEAS, a group that is basing some of its
work on I2RS developed models.

As a WG chair, I have always viewed the models being developed by I2RS
as typical models that are generally useful, and being defined by I2RS
simply because they were ahead of other groups that might otherwise
define the models -- and I view this as a fine thing that has benefit
for YANG users and other WGs. As TEAS chair, this is what lead me to
ensure that the models being defined in TEAS built on the I2RS YANG
modules vs their original path of redefining parallel function.

As part of my view of the I2RS models being generally applicable to uses
beyond I2RS together with I2RS choosing YANG for modeling ephemeral
data, I have always expected that the I2RS WG would at some (perhaps as
part of the I2RS protocol definition) define how any YANG model can be
used to support I2RS. This view certainly lead me to conclude that
having the I2RS models move forward, just like any other YANG model,
makes sense and would benefit the other models and WGs that reference
this core work. This view also allows for the relationship to the
revised-data store work, as well as the specification of which data
store(s) I2RS uses, to be separately defined -- and to not gate
publication of these models. This separate specification would be
the location for any I2RS-specific transport and security considers,
so such would not belong in the generally reusable models developed
by I2RS.

Essentially, As NETMOD co-chair, I concluded that the revised data
store work provided the direction on how ephemeral would be supported
in a general YANG context and, therefore, the major open issue / gating
impediment to progressing I2RS models had been removed and publication
of these models were unblocked. This also motivated my comments in the
related discussions at the last meeting.

If my understanding/view is correct, i.e., that the topology models are
just like any other YANG model, then I think publication can and
should proceed (with the appropriate text for a typical YANG model). If
I misunderstood something, and the models produced by I2RS are limited
to ephemeral representations/data stores as well as specific YANG
transport protocols -- then as TEAS chair, I have to hit reset on the
TEAS topology work, and as NETMOD chair I think the NETMOD WG needs to
discuss what it means for a YANG model to be protocol/datastore
specific and if any guidelines or other new NTEMOD documents are need
to support such.

Less importantly, as I2RS participant, I'd also ask for the documents
to be sent back to the WG for a new last call once the documents
are updated to reflect their narrow scope -- as I bet I'm not the only
person who viewed this work applicable to non-ephemeral uses.

I hope this helps.

Lou

On January 24, 2017 11:56:32 AM "Susan Hares" <[email-masked]> wrote:

> To: Martin:
>
> You have a reasonable request. If the NETMOD WG Chairs confirm their
> decision to make I2RS Yang Modules part of the Control Plane Datastore then
> as shepherd/WG-chair I will recommend these get added to the draft.
>
> Note to authors :
>
> As we wait for the NETMOD WG Chairs and Benoit to deliver the decision on
> Config/Control Plane datastore, the authors should work on:  Basic Yang
> security considerations and the other I2RS Yang Module information.
>
> Sue Hares (Shepherd)
> -----Original Message-----
> From: Martin Bjorklund [mailto:[email-masked]]
> Sent: Tuesday, January 24, 2017 10:39 AM
> To: [email-masked]
> Cc: [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]
> Subject: Re: [i2rs] Kathleen Moriarty's No Objection on
> draft-ietf-i2rs-yang-l3-topology-08: (with COMMENT)
>
> "Susan Hares" <[email-masked]> wrote:
>> Martin:
>>
>>
>>
>> I'm sorry if misunderstood your comments regarding the
>> draft-ietf-netmod-revised-datastores-00.txt.  The reason the answer is
>> unclear is that it depends on the context of the question.
>>
>>
>>
>> .         If you ask if the pre-standardization I2RS Yang Topology models
>> (basic and L3)  implemented are part of the configuration data store,
>> the answer is yes - AFAIK.
>
> This is not my question.
>
>> .         If you ask if the WG LC Topology models are approved to be part
> of
>> the configuration data store, my understanding was no.   I2RS WG was to
>> abide by the decision of NETMOD WG on which data store I2RS modules
>> were placed in.
>
> Yes, this is my question.  And my concern is that even if your understanding
> is that they are not designed to be part of the configuration datastores,
> this fact is not mentioned in the drafts.
>
>> If you are concerned the implementation varies from the standardized,
> please
>> express this to Benoit Claise.   Based on your comments on my email
> thread,
>> I will be brief in my answers today.
>
> This is not my concern.
>
>
> /martin
>
>
>
>>
>>
>>
>> Sue
>>
>>
>>
>>
>>
>> -----Original Message-----
>> From: Martin Bjorklund [mailto:[email-masked]]
>> Sent: Tuesday, January 24, 2017 7:35 AM
>> To: [email-masked]
>> Cc: [email-masked]; [email-masked];
>> [email-masked]; [email-masked];
>> [email-masked]; [email-masked]; [email-masked];
>> [email-masked]; [email-masked]
>> Subject: Re: [i2rs] Kathleen Moriarty's No Objection on
>> draft-ietf-i2rs-yang-l3-topology-08: (with COMMENT)
>>
>>
>>
>> "Susan Hares" < <mailto:[email-masked]> [email-masked]> wrote:
>>
>> > Martin:
>>
>> >
>>
>> > Your statement "One problem is that relying on the solution in
>>
>> > draft-ietf-netmod-revised-datastores-00 is a bit premature - in
>> > fact,
>>
>> > that document does not yet provide any details at all on the I2RS
>>
>> > ephemeral data store." This statement is not what I understood from
>> > IETF
>> 98 or the netmod
>>
>> > ADs.   I guess your objection to this data model falls into Benoit
> Claise
>>
>> > (AD) and the NETMOD folks to answer.
>>
>>
>>
>> Why do you think that I have any objection to
>> draft-ietf-netmod-revised-datastores-00.  Please re-read what I wrote.
>>
>>
>>
>> My objection regards your statement:
>>
>>
>>
>>    1) I2RS Data models do not utilize the configuration data store,
>>
>>
>>
>> If this is true it needs to be clarified in the document.
>>
>>
>>
>> After all these emails back and forth, it is still not clear whether
>> this statement is true or not.
>>
>>
>>
>>
>>
>> /martin
>>
>>
>>
>>
>>
>>
>>
>>
>>
>>
>>
>> >
>>
>> > Sue Hares
>>
>> >
>>
>> > -----Original Message-----
>>
>> > From: i2rs [ <mailto:[email-masked]>
>> > mailto:[email-masked]]
>> On Behalf Of Martin
>>
>> > Bjorklund
>>
>> > Sent: Monday, January 23, 2017 5:26 PM
>>
>> > To:  <mailto:[email-masked]> [email-masked]
>>
>> > Cc:  <mailto:[email-masked]> [email-masked];
>> <mailto:[email-masked]>
>> [email-masked];
>>
>> >  <mailto:[email-masked]>
>> [email-masked];  <mailto:[email-masked]>
>> [email-masked];
>>
>> >  <mailto:[email-masked]> [email-masked];
>> <mailto:[email-masked]>
>> [email-masked]; <mailto:[email-masked]> [email-masked]
>>
>> > Subject: Re: [i2rs] Kathleen Moriarty's No Objection on
>>
>> > draft-ietf-i2rs-yang-l3-topology-08: (with COMMENT)
>>
>> >
>>
>> > "Susan Hares" < <mailto:[email-masked]> [email-masked]> wrote:
>>
>> > > Robert and Martin:
>>
>> > >
>>
>> > > I agree with Robert that the current implementations of the ODL
>>
>> > > topology models are handled as part of the configuration data
>> > > store
>>
>> > > with
>>
>> > ephemeral
>>
>> > > state.   I will point out that these implementation are pre-standards
>>
>> > > implementations of the I2RS YANG Data model.
>>
>> > >
>>
>> > > While standardizing the topology data models, the I2RS WG have
>> > > been
>>
>> > > asked to align with the
>> > > draft-ietf-netmod-revised-datastores-00.txt
>>
>> > > NETMOD WG document.  This NETMOD WG document moves the I2RS
>>
>> > > ephemeral data
>>
>> > store from
>>
>> > > configuration data store to a Control Plane data store.   If we follow
>>
>> > this
>>
>> > > draft, the I2RS Topology models are part of the I2RS ephemeral
>> > > data
>> store.
>>
>> > > If you disagree with the placement of the Topology data models,
>>
>> > > please indicate this to the NETMOD WG and to Benoit.  Could you
>>
>> > > propose a way that you would see the ephemeral state working with
>>
>> > > the configuration data
>>
>> > store
>>
>> > > to the NETMOD WG?
>>
>> > >
>>
>> > > Quite frankly, I feel a bit of whip-lash on this topic.   NETMOD WG
> asks
>>
>> > for
>>
>> > > Control Plane Data store.  You ask for configuration data store
>>
>> > > (which was the I2RS initial proposal).
>>
>> >
>>
>> > Not really; I ask for clarification.
>>
>> >
>>
>> > > It is possible for either one to work for I2RS
>>
>> > > Topology models - if the right details are taken care of.   How do we
>> make
>>
>> > > progress on choosing one method so we can write the I2RS Topology
>>
>> > > Models security considerations.?
>>
>> >
>>
>> > One problem is that relying on the solution in
>>
>> > draft-ietf-netmod-revised-datastores-00 is a bit premature - in
>> > fact,
>>
>> > that document does not yet provide any details at all on the I2RS
>>
>> > ephemeral datastore.
>>
>> >
>>
>> > So I see two alternatives.  Either wait with these documents, or
>>
>> > publish them with their datamodels as is (i.e., no new additional
>>
>> > notes), for the existing protocols and architecure.  This would
>> > allow
>>
>> > them to be implemented just like any other YANG data model.  This
>>
>> > would mean that the normal YANG security considerations guidelines
>> > should
>> be followed.
>>
>> >
>>
>> >
>>
>> >
>>
>> > /martin
>>
>> >
>>
>> > >
>>
>> > > Sue
>>
>> > >
>>
>> > > -----Original Message-----
>>
>> > > From: Robert Varga [ <mailto:[email-masked]> mailto:[email-masked]]
>>
>> > > Sent: Monday, January 23, 2017 4:11 PM
>>
>> > > To: Martin Bjorklund;  <mailto:[email-masked]> [email-masked]
>>
>> > > Cc:  <mailto:[email-masked]> [email-masked];
>> <mailto:[email-masked]>
>> [email-masked];
>>
>> > >  <mailto:[email-masked]>
>> [email-masked];  <mailto:[email-masked]>
>> [email-masked];
>>
>> > >  <mailto:[email-masked]>
>> [email-masked];  <mailto:[email-masked]>
>> [email-masked]
>>
>> > > Subject: Re: [i2rs] Kathleen Moriarty's No Objection on
>>
>> > > draft-ietf-i2rs-yang-l3-topology-08: (with COMMENT)
>>
>> > >
>>
>> > > On 01/23/2017 09:26 PM, Martin Bjorklund wrote:
>>
>> > > >> I'm pulling your questions to the top of this email.
>>
>> > > >>
>>
>> > > >>
>>
>> > > >>
>>
>> > > >> Question 1: Ok.  Just to make sure I understand this correctly
>> > > >> -
>>
>> > > >> these topology models are intended to be I2RS-specific, and
>> > > >> they
>>
>> > > >> cannot be used for any other purpose.  If anyone needs a
>> > > >> general
>>
>> > > >> topology model outside of the I2RS protocol, they will have to
>>
>> > > >> design their own model.  Is this correct?
>>
>> > > >>
>>
>> > > >>
>>
>> > > >>
>>
>> > > >> Response 1:  Not really.
>>
>> > > > Ok, so are you saying that the models are in fact generic, and
>> > > > can
>>
>> > > > be used outside of I2RS?  I.e., they *can* be used with the
>> > > > normal
>>
>> > > > configuration datastores?
>>
>> > > >
>>
>> > >
>>
>> > > From implementation experience, yes, they can be used for storing
>>
>> > > configuration. OpenDaylight uses (an ancient predecessor of)
>>
>> > > yang-network-topo to store configure details about devices in its
>>
>> > > managed networks.
>>
>> > >
>>
>> > > Regards,
>>
>> > > Robert
>>
>> > >
>>
>> > >
>>
>> >
>>
>> > _______________________________________________
>>
>> > i2rs mailing list
>>
>> >  <mailto:[email-masked]> [email-masked]
>>
>> >  <https://www.ietf.org/mailman/listinfo/i2rs>
>> https://www.ietf.org/mailman/listinfo/i2rs
>>
>> >
>>
>
>